#include <stdio.h>
#include <assert.h>
#include <string.h>
#include <sndfile.h>
#include <stdlib.h>
#include "SndfileWavUtil.h"

// foreward declaration. This is defined in DFT.cpp
int DFT(int dir,int m,double *x1,double *y1);

const int Points = 8;

int
do_gen (int argc, char * argv [])
{
  int frames;
  int targ_freqA;
  int targ_freqB;
  char* refWavFile;
  char* outWavFile;
  FILE* outPCM;
  const int short_sz = sizeof(short int);

  frames = atoi(argv[1]);
  targ_freqA = atoi(argv[2]);
  targ_freqB = atoi(argv[3]);
  refWavFile = argv[4];
  outWavFile = argv[5];

  outPCM = fopen("output.pcm", "w");

  printf("targ_freqA %d\ntarg_freqB %d\nframes %d\n", targ_freqA, targ_freqB, frames);

  while(frames-- > 0){

    double dreal[Points];
    double dimag[Points];

    for(int i = 0; i < Points; i++)
      dreal[i] = (i == targ_freqA) ? 1000 : (i == targ_freqB) ? 1000 : 0;
    for(int i = 0; i < Points; i++)
      dimag[i] = 0.0;
    
    DFT(-1,Points,dreal,dimag);

    for(int i = 0; i < Points; i++){
      short int rv = (int)dreal[i];
      assert(fwrite(&rv,short_sz,1,outPCM));
    }

  }

  fclose(outPCM);

  generate_wav("output.pcm", refWavFile, outWavFile);
}

int
main(int argc, char* argv[])
{
  do_gen(argc, argv);
  exit(1);
}
